﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace MetroStyleInheritnaceTest
{
    public class ViewModel : INotifyPropertyChanged
    {
        /// <summary>
        /// data
        /// </summary>
        private ObservableCollection<complex> data;

        /// <summary>
        /// Data
        /// </summary>			
        public ObservableCollection<complex> Data
        {
            get { return data; }
            set { data = value; OnPropertyChanged("Data"); }
        }
        

        public ViewModel()
        {
            Data = new ObservableCollection<complex>();
            for (int i = 0; i < 50; i++)
            {
                Data.Add(
                    new complex()
                    {
                        Id = i,
                        Name = "Name" + " .... " + i.ToString(),
                        Proffession = "Bauarbeiter ..... " + i.ToString()
                    });
            }
        }

        public void OnPropertyChanged(string blub){
        
            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(blub));
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }


    public class complex : INotifyPropertyChanged
    {
        /// <summary>
        /// proffession
        /// </summary>
        private string proffession;

        /// <summary>
        /// Proffession
        /// </summary>			
        public string Proffession
        {
            get { return proffession; }
            set { proffession = value; OnPropertyChanged("Proffession"); }
        }
        

        /// <summary>
        /// name
        /// </summary>
        private string name;

        /// <summary>
        /// Name
        /// </summary>			
        public string Name
        {
            get { return name; }
            set { name = value; OnPropertyChanged("Name"); }
        }
        
        /// <summary>
        /// id
        /// </summary>
        private int id;

        /// <summary>
        /// Id
        /// </summary>			
        public int Id
        {
            get { return id; }
            set { id = value; OnPropertyChanged("Id"); }
        }
        

        public void OnPropertyChanged(string blub)
        {

            if (PropertyChanged != null)
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(blub));
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
